<?
  /*
   * Connector for the arduino controller to set the actual state and to get new orders
   */
  require_once('./inc/BrewRecipe.class.php');
  require_once('./inc/BrewControl.class.php');
  require_once('./inc/dbconn.php');                // definiert das Objekt $dbconn
  //header('Content-Type: application/octet-stream');

  ini_set('display_errors', TRUE);

  $anlagen = array();
  $success = true;
  $aktanlage=0;

  // Werte der aktuellen Anlage holen und ändern
  $anlagen = apc_fetch("brewcontrols", $success);
  if (!$success) {
    for ($i=0; $i < $AnzAnlagen; $i++) {
      $anlagen[$i] = new BrewControl();
    }
  }

  if ($_SERVER['REQUEST_METHOD'] == "GET") {
    if (isset($_GET['a'])  && is_numeric($_GET['a']))  $aktanlage = $_GET['a']-1;
    if (isset($_GET['order']))                         $order     = $_GET['order']; else $order = '';

    $anlidx = $aktanlage + 1;       // Anlagennummer beginnt in der DB auch bei 1
    
    if (!array_key_exists($aktanlage, $anlagen))
      $anlagen[$aktanlage] = new BrewControl();

    $anlagen[$aktanlage]->lastconnect = date('d.M.Y H:i:s');

    switch($order) {
      case 'donothing':                   // Nichts tun bzw. ausschalten
        break;
      case 'settemp':
        break;
      case 'startprog':
        break;
      default:                            // das kommt normalerweise vom Arduino
        // Ist es eine Bestätigung eines Einstellungs-Kommandos?
        if (isset($_GET['confirm'])) {
          $anlagen[$aktanlage]->actorder = chr(0);
          $anlagen[$aktanlage]->meldung = '';
        } elseif (isset($_GET['message'])) {
          if ($anlagen[$aktanlage]->recipe->IsStarted) {
            $SudID = $anlagen[$aktanlage]->recipe->sudid;                                         // Zur Unterscheidung einzelner Sude
          } else {
            $SudID = 0;
          }
          // keine neuen Aufträge an die Steuerung senden. Erstmal die Meldungsquittierung abwarten
          $anlagen[$aktanlage]->actorder = chr(0);
          $anlagen[$aktanlage]->meldung = $_GET['message'];
          $dbconn->query("INSERT INTO Logfile (LogText, AnlagenNr, Sud_ID) VALUES ('Message from device : {$_GET['message']}', {$anlidx}, $SudID)");
        } else {
          // Werte übernehmen und im APC speichern
          if (isset($_GET['t1']) && is_numeric($_GET['t1'])) $anlagen[$aktanlage]->temp[0] = round($_GET['t1'],1);
          if (isset($_GET['t2']) && is_numeric($_GET['t2'])) $anlagen[$aktanlage]->temp[1] = round($_GET['t2'],1);
          if (isset($_GET['t3']) && is_numeric($_GET['t3'])) $anlagen[$aktanlage]->temp[2] = round($_GET['t3'],1);
          if (isset($_GET['t4']) && is_numeric($_GET['t4'])) $anlagen[$aktanlage]->temp[3] = round($_GET['t4'],1);
          if (isset($_GET['r'])  && is_numeric($_GET['r']))  $anlagen[$aktanlage]->relbits = round($_GET['r'],0);

          // Temperatur-Werte auch an die DB senden
          
          // Maische-Temperaturen sind nur interessant, wenn auch was geregelt werden soll
          if (($anlagen[$aktanlage]->temp[0] != -50) && (substr($anlagen[$aktanlage]->actorder, 0,1)  == chr(1))) {
            $dbconn->query("CALL spAddTemperature ({$anlidx}, 0, {$anlagen[$aktanlage]->zieltemp});");   // Zieltemperatur gleich mitloggen
            $dbconn->query("CALL spAddTemperature ({$anlidx}, 1, {$anlagen[$aktanlage]->temp[0]});");
            }
          if ($anlagen[$aktanlage]->temp[1] != -50)       // -50° sendet die Steuerung für einen undefinierten Sensor
            $dbconn->query("CALL spAddTemperature ({$anlidx}, 2, {$anlagen[$aktanlage]->temp[1]});");
          if ($anlagen[$aktanlage]->temp[2] != -50)       // -50° sendet die Steuerung für einen undefinierten Sensor
            $dbconn->query("CALL spAddTemperature ({$anlidx}, 3, {$anlagen[$aktanlage]->temp[2]});");
          if ($anlagen[$aktanlage]->temp[3] != -50)       // -50° sendet die Steuerung für einen undefinierten Sensor
            $dbconn->query("CALL spAddTemperature ({$anlidx}, 4, {$anlagen[$aktanlage]->temp[3]});");

          // Wenn ein Maischprogramm aktiv ist, dann abarbeiten
          if ($anlagen[$aktanlage]->recipe->IsStarted) {
            $SudID = $anlagen[$aktanlage]->recipe->sudid;                                         // Zur Unterscheidung einzelner Sude
            $step = $anlagen[$aktanlage]->recipe->aktrast;

            // Wurde die aktuelle Zieltemperatur des Schritts schon erreicht?
            // Wenn ja, dann prüfen, ob sie schon fertig ist.
            // Wenn nein, dann warten, bis das Heizen fertig ist.
            if (isset($anlagen[$aktanlage]->recipe->rastbeginn[$step])) {
              $now = new DateTime();

              // Wurde ein Warten bestätigt?
              if ($anlagen[$aktanlage]->recipe->warten[$step] && $anlagen[$aktanlage]->recipe->bestaetigt[$step]) {
                if ($step < (count($anlagen[$aktanlage]->recipe->dauer))-1) {
                  $dbconn->query("INSERT INTO Logfile (LogText, AnlagenNr, Sud_ID) VALUES ('Mashprog next step reached', {$anlidx}, $SudID)");
                  $anlagen[$aktanlage]->recipe->aktrast++;        // weiter zum nächsten Schritt, wenn einer da war
                  $anlagen[$aktanlage]->meldung = '';
                  $step = $anlagen[$aktanlage]->recipe->aktrast;
                } else {
                  $anlagen[$aktanlage]->recipe->IsStarted = FALSE;      // anscheinend Ende Gelände
                  $anlagen[$aktanlage]->meldung = '';
                  $anlagen[$aktanlage]->rastdauer = "-";
                  
                  // Ende des Programm mitloggen, damit die Temperaturwerte des Maischens zugeordnet werden können.
                  $dbconn->query("CALL spAddTemperature ({$anlidx}, 0, 0);");   // Zieltemperatur gleich mitloggen
                  $dbconn->query("INSERT INTO Logfile (LogText, AnlagenNr, Sud_ID) VALUES ('Mashprog ended', {$anlidx}, $SudID)");
                  $anlagen[$aktanlage]->recipe->sudid = 0;
                }
              }

              // Wurde die Zieltemperatur vorher schon erreicht ?
              if ($anlagen[$aktanlage]->recipe->rastbeginn[$step]) {
                $minutes = $anlagen[$aktanlage]->recipe->rastbeginn[$step]->diff($now);

                // Rest gleich in die Anzeige übernehmen
                $anlagen[$aktanlage]->rastdauer = $minutes->format("%i:%s") . "/" . $anlagen[$aktanlage]->recipe->dauer[$step] . ":00";
                $seconds  = $minutes->i*60 + $minutes->s ;

                // Dauer erreicht?
                if ($seconds >= $anlagen[$aktanlage]->recipe->dauer[$step] * 60) {
                  if ($anlagen[$aktanlage]->recipe->warten[$step]) {
                    $anlagen[$aktanlage]->recipe->bestaetigt[$step] = FALSE;
                    $anlagen[$aktanlage]->meldung = $anlagen[$aktanlage]->recipe->nachricht[$step];
                  } else {
                    if ($step < (count($anlagen[$aktanlage]->recipe->dauer))-1) {
                      $anlagen[$aktanlage]->recipe->aktrast++;      // nicht warten, also einfach weiter zum nächsten Schritt
                      $anlagen[$aktanlage]->meldung = '';
                      $step = $anlagen[$aktanlage]->recipe->aktrast;
                    } else {
                      
                      $anlagen[$aktanlage]->recipe->IsStarted = FALSE;      // anscheinend Ende Gelände
                      $anlagen[$aktanlage]->meldung   = '';
                      $anlagen[$aktanlage]->zieltemp  = 0;
                      $anlagen[$aktanlage]->rastdauer = "-";

                      // Ende des Programm mitloggen, damit die Temperaturwerte des Maischens zugeordnet werden können.
                      $dbconn->query("CALL spAddTemperature ({$anlidx}, 0, 0);");   // Zieltemperatur gleich mitloggen
                      $dbconn->query("INSERT INTO Logfile (LogText, AnlagenNr, Sud_ID) VALUES ('Mashprog ended', {$anlidx}, $SudID)");
                      $anlagen[$aktanlage]->recipe->sudid = 0;
                    }
                  }
                }
              }
            } else {
              $anlagen[$aktanlage]->rastdauer = "--/" . $anlagen[$aktanlage]->recipe->dauer[$step] . ":00";
              // 27.12.2014 Rastbeginn schon 0,5° vorher starten
              if ($anlagen[$aktanlage]->temp[0] + 0.5 >= $anlagen[$aktanlage]->recipe->temp[$step]) {
                $anlagen[$aktanlage]->recipe->rastbeginn[$step] = new DateTime();      // Rastbeginn setzen
              } elseif ($anlagen[$aktanlage]->recipe->temp[$step] > 95) {              // Soll es kochen ? Das kann manchmal schon früher einsetzen und nicht höher gehen... also auch früher zählen
                if ($anlagen[$aktanlage]->temp[0] >= 95) {                             // Alles oberhalb 95° als Kochen betrachten
                  $anlagen[$aktanlage]->recipe->rastbeginn[$step] = new DateTime();              
                }
              }
            }

            // noch nicht oder gerade eben erreicht, also gilt die Devise "Heizen auf Zieltemperatur des akt. Schritts"
            if ($anlagen[$aktanlage]->recipe->IsStarted) {
              $anlagen[$aktanlage]->zieltemp = $anlagen[$aktanlage]->recipe->temp[$step];     // für die Anzeige 
              $anlagen[$aktanlage]->actorder = chr(1) . chr($anlagen[$aktanlage]->recipe->temp[$step]);
            } else {
              $anlagen[$aktanlage]->actorder = chr(0);
              $anlagen[$aktanlage]->meldung = '';
              $anlagen[$aktanlage]->rastdauer = "-";
            }
          }    // if ($anlagen[$aktanlage]->recipe->IsStarted)
        }                   // normale Anfrage, keine Bestätigung oder Fehlermeldung
        apc_store("brewcontrols", $anlagen, 600);
    }                                                                                 // switch($order)

    // aktuelle Order an die Steuerung liefern
    echo $anlagen[$aktanlage]->actorder;
  } elseif ($_SERVER['REQUEST_METHOD'] == "POST") {
  }
?>
