<?
  /*
   * Connector for the control client to manage orders for the controller
   * and get the actual state of the different controllers
   */

  require_once('./inc/BrewRecipe.class.php');
  require_once('./inc/BrewControl.class.php');
  require_once('./inc/dbconn.php');                // definiert das Objekt $dbconn
  header('Content-Type: application/json');

  ini_set('display_errors', TRUE);

  // Akt. Status einlesen
  $success = true;
  $anlagen = apc_fetch("brewcontrols", $success);
  if (!$success) {
    for ($i=0; $i < $AnzAnlagen; $i++) {
      $anlagen[$i] = new BrewControl();
    }
  }


  // Daten holen geht schnell
  if ($_SERVER['REQUEST_METHOD'] == "GET") {
    if (isset($_GET['temps'])) {                            // Temp-Werte für die aktuelle Anlage holen
      $aktanlage = 0;
      if (isset($_GET['a'])  && is_numeric($_GET['a']))  $aktanlage = $_GET['a'];
      $aktanlagedb = $aktanlage;
      $data= array();
      $lasttime = 0;
      $sql = "SELECT * FROM ( SELECT UNIX_TIMESTAMP(TempTime) * 1000 AS datetime, Value AS value
                                FROM TempValues
                               WHERE Temperatur_ID = (SELECT Temperatur_ID FROM TempDefs WHERE AnlagenNr = {$aktanlagedb} AND SensorNr = 1 )
                                 AND TempTime >= (SELECT MAX(logTime) FROM Logfile WHERE LogText = 'Mashprog started' AND AnlagenNr = {$aktanlagedb})
                                 AND TempTime <= (SELECT IFNULL(MAX(logTime), '2100-01-01') FROM Logfile 
                                                   WHERE LogText = 'Mashprog ended' AND AnlagenNr = {$aktanlagedb}
                                                     AND logTime > (SELECT MAX(logTime) FROM Logfile WHERE LogText = 'Mashprog started' AND AnlagenNr = {$aktanlagedb}))
                               ORDER BY TempTime DESC LIMIT 200 ) AS DD
                      ORDER BY datetime";
      $result = $dbconn->query($sql);
      if ($result) {
        while ($row = $result->fetch_array()) {
          $data[] = array((int)$row['datetime'], (float)$row['value']);
          $lasttime = (int)$row['datetime'];
        }
        $result->free();
      }
      // if no data is available, send some dummy data
      if (count($data) == 0) {
        $data[] = array(time()*1000, 5.0);
        $data[] = array((time() + 5)*1000, 5.0);
      }
      $sdata= array();
      $sql = "SELECT * FROM ( SELECT UNIX_TIMESTAMP(TempTime) * 1000 AS datetime, Value AS value
                                FROM TempValues
                               WHERE Temperatur_ID = (SELECT Temperatur_ID FROM TempDefs WHERE AnlagenNr = {$aktanlagedb} AND SensorNr = 0 )
                                 AND TempTime >= (SELECT MAX(logTime) FROM Logfile WHERE LogText = 'Mashprog started' AND AnlagenNr = {$aktanlagedb})
                                 AND TempTime <= (SELECT IFNULL(MAX(logTime), '2100-01-01') FROM Logfile 
                                                   WHERE LogText = 'Mashprog ended' AND AnlagenNr = {$aktanlagedb}
                                                     AND logTime > (SELECT MAX(logTime) FROM Logfile WHERE LogText = 'Mashprog started' AND AnlagenNr = {$aktanlagedb}))
                               ORDER BY TempTime DESC LIMIT 200 ) AS DD
                      ORDER BY datetime";
      $result = $dbconn->query($sql);
      $lasttemp = 0.0;
      if ($result) {
        while ($row = $result->fetch_array()) {
          $sdata[] = array((int)$row['datetime'], (float)$row['value']);
          $lasttemp = (float)$row['value'];         // 
        }
        $result->free();
        
        // Noch einen Datensatz mit dem letzten Zielwert mit der letzten Zeit anfügen, damit da eine durchgezogene Linie erscheint
        $sdata[] = array($lasttime, $lasttemp);        
      }
      // if no data is available, send some dummy data
      if (count($sdata) == 0) {
        $sdata[] = array(time()*1000, 5.0);
        $sdata[] = array((time() + 5)*1000, 5.0);
      }
      echo json_encode(array("Ist"=>$data, "Soll"=>$sdata));

    } elseif ($_GLOBALS['KBH'] && isset($_GET['malts'])) {                      // Schüttung für ein Rezept holen
      if (isset($_GET['SudID']) && is_numeric($_GET['SudID']))
        $aktsud = $_GET['SudID'];
      else
        $aktsud = 1;

      $data = "";
      $sql = "SELECT Name AS Malz, ROUND(erg_Menge,2) AS Menge FROM Malzschuettung WHERE SudID = {$aktsud}";
      $result = $kbdb->query($sql);
      $data .= '<table data-role="table" id="malts-table" data-mode="reflow" class="ui-responsive">';
      if ($result) {
        while ($row = $result->fetchArray()) {
          $data .= "<tr><td>" . $row['Malz'] . "</td><td class='ui-li-aside'>". $row['Menge'] . " kg</td></tr>\n";
        }
      }
      $data .= "</table>\n";
      echo json_encode($data);

    } elseif ($_GLOBALS['KBH'] && isset($_GET['infos'])) {                      // Daten über ein Bier holen
      if (isset($_GET['SudID']) && is_numeric($_GET['SudID']))
        $aktsud = $_GET['SudID'];
      else
        $aktsud = 1;

      $data = '<table data-role="table" id="info-table" data-mode="reflow" class="ui-responsive">';

      // zuerst allgemeine Sudinfos
      $sql = "SELECT Kommentar, IBU AS IBU, strftime('%d.%m.%Y', Braudatum) AS gebrautAm,
                     strftime('%d.%m.%Y', AbfuellDatum) AS abgefuelltAm, erg_Alkohol AS Alk,
                     erg_AbgefuellteBiermenge AS BMenge, AuswahlHefe AS Hefe
                FROM Sud
               WHERE ID = {$aktsud}";
      $result = $kbdb->query($sql);
      if ($result) {
      	$row = $result->fetchArray();
      	//print_r($row);
        $data .= "<tr><td colspan='2'><b>Allg. Infos</b></td></tr>\n";
        $data .= "<tr><td>gebraut am </td><td class='ui-li-aside'>{$row['gebrautAm']}</td></tr>\n";
        $data .= "<tr><td>abgefüllt am</td><td class='ui-li-aside'>{$row['abgefuelltAm']}</td></tr>\n";
        $data .= "<tr><td>Allo-Ool</td><td class='ui-li-aside'>{$row['Alk']} %</td></tr>\n";
        $data .= "<tr><td>IBU</td><td class='ui-li-aside'>{$row['IBU']}</td></tr>\n";
        $data .= "<tr><td>Menge</td><td class='ui-li-aside'>{$row['BMenge']} L</td></tr>\n";
        $data .= "<tr><td>Hefe</td><td class='ui-li-aside'>{$row['Hefe']}</td></tr>\n";
        $comment = $row['Kommentar'];
      }

      // danach die Schüttung prozentual ausrechnen
      $data .= "<tr><td colspan='2'><b>Malz</b></td></tr>\n";
      $sql = "SELECT Malz, GesamtMalz,  Menge, ROUND(Menge/GesamtMalz * 100 ,1) AS Anteil
                FROM (SELECT Name AS Malz, ROUND(erg_Menge,2) AS Menge ,
                             (SELECT ROUND(SUM(erg_Menge),2) FROM Malzschuettung M2 WHERE M2.SudID = MS.SudID) AS GesamtMalz
                        FROM Malzschuettung MS
                       WHERE SudID = {$aktsud})";
      $result = $kbdb->query($sql);
      if ($result) {
        while ($row = $result->fetchArray()) {
          $data .= "<tr><td>{$row['Malz']}</td><td class='ui-li-aside'>{$row['Anteil']} %</td></tr>\n";
        }
      }

      $data .= "<tr><td colspan='2'><b>Hopfen</b></td></tr>\n";
      $sql = "SELECT Name || '(' || Alpha || '% &alpha;)' AS Name, Zeit || ' min.' AS Zeit
                FROM Hopfengaben
               WHERE Aktiv <> 0 AND SudID = {$aktsud} ORDER BY Zeit DESC";
      $result = $kbdb->query($sql);
      if ($result) {
        while ($row = $result->fetchArray()) {
          $data .= "<tr><td>{$row['Name']}</td><td class='ui-li-aside'>{$row['Zeit']}</td></tr>\n";
        }
      }

      $data .= "<tr><td colspan='2'><b>Kommentar</b></td></tr>\n";
      $data .= "<tr><td colspan='2'>{$comment}</td></tr>\n";
      $data .= "</table>\n";
      echo json_encode($data);
    } else {
      echo json_encode($anlagen);
    }
  } elseif ($_SERVER['REQUEST_METHOD'] == "POST") {
    if (substr($_SERVER['REMOTE_ADDR'], 0, 9) == '192.168.1') {          // nur von zuhause aus steuerbar
      // aus den Parametern erst die gewünschte Anlage raussuchen
      $aktanlage = 0;
      if (isset($_POST['a'])  && is_numeric($_POST['a']))  $aktanlage  = $_POST['a']-1;
      if (!array_key_exists($aktanlage, $anlagen))
        $anlagen[$aktanlage] = new BrewControl();


      switch($_POST['order']) {
        case 'donothing':                   // Nichts tun bzw. ausschalten
          $SudID = $anlagen[$aktanlage]->recipe->sudid;
          $anlagen[$aktanlage]->actorder = chr(0);
          $anlagen[$aktanlage]->recipe->IsStarted = FALSE;    // Aktuelles Rezept ggf. auch stoppen
          $anlagen[$aktanlage]->meldung = "";
          $anlagen[$aktanlage]->zieltemp = 0;
          $anlagen[$aktanlage]->recipe->sudid = 0;
          apc_store("brewcontrols", $anlagen, 600);
          $aktanlagedb = $aktanlage+1;
          $dbconn->query("INSERT INTO Logfile (LogText, AnlagenNr, Sud_ID) VALUES ('Abbruch.', {$aktanlagedb}, {$SudID})");
          break;

        case 'settemp':
          if (isset($_POST['temp'])) {      // normale Temperaturregelung: Temperatur übernehmen
            $anlagen[$aktanlage]->actorder = chr(1) . chr($_POST['temp']);
            $anlagen[$aktanlage]->zieltemp = $_POST['temp'];
            apc_store("brewcontrols", $anlagen, 600);
            $aktanlagedb = $aktanlage+1;
            $dbconn->query("INSERT INTO Logfile (LogText, AnlagenNr) VALUES ('Man. Temp.-Regelung auf Temperatur {$_POST['temp']} °C.', $aktanlagedb)");
          }
          break;

        case 'confirm':           // Meldungen des Maischprogramms bestätigen
          // Aktuelle Rezepte laden, wenn welche da sind
          $rastnum = $anlagen[$aktanlage]->recipe->aktrast;
          $anlagen[$aktanlage]->recipe->bestaetigt[$rastnum]    = TRUE;
          apc_store("brewcontrols", $anlagen, 600);                                               // ...und speichern
          $SudID = $anlagen[$aktanlage]->recipe->sudid;                                           // Zur Unterscheidung einzelner Sude
          $aktanlagedb = $aktanlage+1;
          $dbconn->query("INSERT INTO Logfile (LogText, AnlagenNr, Sud_ID) VALUES ('Rast $rastnum bestätigt.', {$aktanlagedb}, {$SudID})");
          break;

        case 'startprog':         // Maischprogramm starten
          if ($_GLOBALS['KBH'] && $_POST['rezdata'][$aktanlage] != 0) {                           // wurde ein KBH-Rezept ausgewählt?
            $SudID = $_POST['rezdata'][$aktanlage];

            $sql = "  SELECT 0 AS Sort1, EinmaischenTemp AS Temp, 0 AS Dauer, 'Aufheizen zum Einmaischen' AS Name FROM Sud WHERE ID = {$SudID}
                    UNION
                      SELECT ID AS Sort1, RastTemp AS Temp, RastDauer AS Dauer, RastName AS Name     FROM Rasten WHERE SudID = {$SudID} AND RastAktiv = 1
                    ORDER BY Sort1, RastTemp";
            // Rezept aus der KBH-DB holen
            $res= $kbdb->query($sql);
            $anlagen[$aktanlage]->recipe->reset();                                                // Default-Rezeptschritte löschen

            while($row = $res->fetchArray()) {
              $anlagen[$aktanlage]->recipe->temp[]      = $row['Temp'];
              $anlagen[$aktanlage]->recipe->dauer[]     = $row['Dauer'];
              $anlagen[$aktanlage]->recipe->name[]      = $row['Name'];
              $anlagen[$aktanlage]->recipe->warten[]    = FALSE;
              $anlagen[$aktanlage]->recipe->bestaetigt[]= FALSE;
              $anlagen[$aktanlage]->recipe->nachricht[] = '';
              $anlagen[$aktanlage]->recipe->rastbeginn[]= null;
            }    // while

            // wie viele Rasten sind es denn ?
            $rastcount = count($anlagen[$aktanlage]->recipe->temp);
            echo "Anzahl Rasten: $rastcount \n";

            // nach der ersten Rast warten bis eingemaischt ist
            $anlagen[$aktanlage]->recipe->nachricht[0]  = 'Schrot rein';
            $anlagen[$aktanlage]->recipe->warten[0]     = TRUE;
            $anlagen[$aktanlage]->recipe->bestaetigt[0] = FALSE;

            // nach der vorletzten Rast warten auf die Jodprobe
            $anlagen[$aktanlage]->recipe->nachricht[$rastcount-2]  = 'Jodprobe';
            $anlagen[$aktanlage]->recipe->warten[$rastcount-2]     = TRUE;
            $anlagen[$aktanlage]->recipe->bestaetigt[$rastcount-2] = FALSE;

            // nach der vorletzten Rast warten auf die Jodprobe
            $anlagen[$aktanlage]->recipe->nachricht[$rastcount-1]  = 'Alles aus';
            $anlagen[$aktanlage]->recipe->warten[$rastcount-1]     = TRUE;
            $anlagen[$aktanlage]->recipe->bestaetigt[$rastcount-1] = FALSE;
            
            $anlagen[$aktanlage]->recipe->aktrast      = 0;

            $anlagen[$aktanlage]->recipe->IsStarted    = TRUE;                                    // ...und los geht's

            echo "Hole Rezept Nr. $SudID \n";
            print_r($anlagen[$aktanlage]->recipe);
          } else {                                                                                // if KBH
            $anlagen[$aktanlage]->recipe->reset();                                                // Default-Rezeptschritte löschen
            $SudID = time();
            if (isset($_POST['rastanz'][$aktanlage])) {                                           // Rezept übernehmen und starten
              $rastcount = $_POST['rastanz'][$aktanlage];
              $anlagen[$aktanlage]->recipe->IsStarted    = TRUE;                                  // Erst zum Einmaischen hochheizen

              $anlagen[$aktanlage]->recipe->aktrast      = 0;
              $anlagen[$aktanlage]->recipe->temp[0]      = $_POST['starttemp'][$aktanlage];          // Einmaischen bei Temperatur
              $anlagen[$aktanlage]->recipe->dauer[0]     = 0;                                     // gleich weiter nach dem Einmaischen
              $anlagen[$aktanlage]->recipe->name[0]      = "Aufheizen zum Einmaischen";
              $anlagen[$aktanlage]->recipe->nachricht[0] = 'Schrot rein';                         // Meldung bei Ende der Rast
              $anlagen[$aktanlage]->recipe->warten[0]    = TRUE;                                  // Soll am Ende der Rast gewartet werden?
              $anlagen[$aktanlage]->recipe->bestaetigt[0]= FALSE;
              $anlagen[$aktanlage]->recipe->rastbeginn[0]= null;

              // Eingegebene Rasten übernehmen
              for($i = 1; $i <= $rastcount; $i++ ) {
                $anlagen[$aktanlage]->recipe->temp[$i]      = $_POST['rasttemp'][$aktanlage][$i-1];
                $anlagen[$aktanlage]->recipe->dauer[$i]     = $_POST['rastdauer'][$aktanlage][$i-1];
                $anlagen[$aktanlage]->recipe->name[$i]      = "Rast Nr. ".($i);
                $anlagen[$aktanlage]->recipe->nachricht[$i] = '';
                $anlagen[$aktanlage]->recipe->warten[$i]    = FALSE;
                $anlagen[$aktanlage]->recipe->bestaetigt[$i]= FALSE;
                $anlagen[$aktanlage]->recipe->rastbeginn[$i]= null;
              }

              // Eingegebene Rasten übernehmen
              $anlagen[$aktanlage]->recipe->temp[$rastcount+1]      = $_POST['endtemp'][$aktanlage]; // Einmaischen bei Temperatur
              $anlagen[$aktanlage]->recipe->dauer[$rastcount+1]     = 0;                          // gleich weiter nach dem Einmaischen
              $anlagen[$aktanlage]->recipe->name[$rastcount+1]      = "Aufheizen zum Abmaischen";
              $anlagen[$aktanlage]->recipe->nachricht[$rastcount+1] = 'Alles aus';                // Meldung bei Ende der Rast
              $anlagen[$aktanlage]->recipe->warten[$rastcount+1]    = TRUE;                       // Soll am Ende der Rast gewartet werden?
              $anlagen[$aktanlage]->recipe->bestaetigt[$rastcount+1]= FALSE;
              $anlagen[$aktanlage]->recipe->rastbeginn[$rastcount+1]= null;

              $anlagen[$aktanlage]->meldung = '';
            }
          }
          $anlagen[$aktanlage]->recipe->sudid = $SudID;                                         // Zur Unterscheidung einzelner Sude
          // Start des Programm mitloggen, damit die Temperaturwerte des Maischens zugeordnet werden können.
          $aktanlagedb = $aktanlage+1;
          $dbconn->query("INSERT INTO Logfile (LogText, AnlagenNr, Sud_ID) VALUES ('Mashprog started', {$aktanlagedb}, {$SudID})");

          apc_store("brewcontrols", $anlagen, 600);                                             // ...und speichern
          break;

        case 'addtemp':           // akt. Rasttemp um 1° erhöhen
          $rastnum = $anlagen[$aktanlage]->recipe->aktrast;
          $anlagen[$aktanlage]->recipe->temp[$rastnum] +=1;
          apc_store("brewcontrols", $anlagen, 600);
          break;
        case 'subtemp':           // akt. Rasttemp um 1° senken
          $rastnum = $anlagen[$aktanlage]->recipe->aktrast;
          $anlagen[$aktanlage]->recipe->temp[$rastnum] -= 1;
          apc_store("brewcontrols", $anlagen, 600);
          break;
        case 'addtime':           // akt. Rastzeit um 5 Minuten erhöhen
          $rastnum = $anlagen[$aktanlage]->recipe->aktrast;
          $anlagen[$aktanlage]->recipe->dauer[$rastnum] += 5;
          apc_store("brewcontrols", $anlagen, 600);
          break;
        case 'subtime':           // akt. Rastzeit um 5 Minuten verringern
          $rastnum = $anlagen[$aktanlage]->recipe->aktrast;
          $anlagen[$aktanlage]->recipe->dauer[$rastnum] -= 5;
          apc_store("brewcontrols", $anlagen, 600);
          break;

        case 'setsensors':
          if (isset($_POST['sensorno'])) {      // Einstellungen: Adresse Sensor x suchen
            $anlagen[$aktanlage]->actorder = chr(0x10) . chr($_POST['sensorno']);
            apc_store("brewcontrols", $anlagen, 600);
          }
          break;

        case 'setdeviation':
          if (isset($_POST['sensornr'])) {      // Einstellungen: Messabweichung für Sensor x einstellen
            $anlagen[$aktanlage]->actorder = chr(0x11) . chr($_POST['sensornr']) . chr($_POST['deviation']);
            apc_store("brewcontrols", $anlagen, 600);
          }
          break;

        case 'setheaters':
          if (isset($_POST['heaters'])) {      // Einstellungen: Anzahl Heizkreise einstellen
            $anlagen[$aktanlage]->actorder = chr(0x12) . chr($_POST['heaters']);
            apc_store("brewcontrols", $anlagen, 600);
          }
          break;

        case 'setanlnr':
          if (isset($_POST['anlnr'])) {      // Einstellungen: Anlagennr. einstellen
            $anlagen[$aktanlage]->actorder = chr(0x13) . chr($_POST['anlnr']);
            apc_store("brewcontrols", $anlagen, 600);
          }
          break;

        case 'setmaxsonic':                  // Einstellungen: Lerne max. Wasserabstand zum Ultraschallsensor (=Mindestfüllmenge)
          $anlagen[$aktanlage]->actorder = chr(0x14);
          apc_store("brewcontrols", $anlagen, 600);
          break;

        /*
        case 'setipvalues':
          if (isset($_POST['sensorno'])) {   // Einstellungen: Anzahl Heizkreise einstellen
            $anlagen[$aktanlage]->actorder = chr(0x15) . chr($_POST['sensorno']);
            apc_store("brewcontrols", $anlagen, 600);
          }
          break;
        */
        case 'sethyst':                     // Werte für die Hysterese senden
          $anlagen[$aktanlage]->actorder = chr(0x1A) . chr($_POST['firstoff']*10) . chr($_POST['secondon']*10) . chr($_POST['heizzeit']);
          apc_store("brewcontrols", $anlagen, 600);
          break;
          
        case 'sendsettings':                 // Werte der Steuerung senden lassen
          $anlagen[$aktanlage]->actorder = chr(0x19);
          apc_store("brewcontrols", $anlagen, 600);
          break;

        case 'savesettings':                 // Einstellungen im EEPROM speichern
          $anlagen[$aktanlage]->actorder = chr(0x16);
          apc_store("brewcontrols", $anlagen, 600);
          break;
/*
        case 'autotune':                     // PID Parameter automatisch ermitteln
          $anlagen[$aktanlage]->actorder = chr(0x18);
          apc_store("brewcontrols", $anlagen, 600);
          break;
*/
        case 'reset':
          $anlagen[$aktanlage]->actorder = chr(20);
          apc_store("brewcontrols", $anlagen, 600);
          break;

        default:
      }                                           // switch

      // aktuellen Status zurückliefern
      echo json_encode($anlagen);
    } else {                                      // if (substr($_SERVER['REMOTE_ADDR']
      echo "Kucken ja, steuern NEIN";
    }
  }
?>
