-- MySQL dump 10.13  Distrib 5.5.35, for debian-linux-gnu (x86_64)
--
-- Host: localhost    Database: druckbraeu_db
-- ------------------------------------------------------
-- Server version	5.5.35-0ubuntu0.12.04.2

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

SELECT * FROM information_schema.SCHEMATA WHERE SCHEMA_NAME = 'druckbraeu_db';

--
-- Table structure for table `Anlagen`
--

DROP TABLE IF EXISTS `Anlagen`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `Anlagen` (
  `AnlagenNr`      int(11) NOT NULL AUTO_INCREMENT,
  `Bezeichnung`    varchar(50) NOT NULL DEFAULT '',
  PRIMARY KEY (`AnlagenNr`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8 COMMENT='utf8_general_ci';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `Anlagen`
--

LOCK TABLES `Anlagen` WRITE;
/*!40000 ALTER TABLE `Anlagen` DISABLE KEYS */;
INSERT INTO `Anlagen` VALUES (1,'Grosser Topf'),(2,'Einkocher');
/*!40000 ALTER TABLE `Anlagen` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `Logfile`
--

DROP TABLE IF EXISTS `Logfile`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `Logfile` (
  `idLog`          int(11) NOT NULL AUTO_INCREMENT,
  `LogTime`        timestamp NULL DEFAULT CURRENT_TIMESTAMP,
  `LogText`        varchar(200) DEFAULT NULL,
  PRIMARY KEY (`idLog`)
) ENGINE=InnoDB AUTO_INCREMENT=37 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `TempDefs`
--

DROP TABLE IF EXISTS `TempDefs`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `TempDefs` (
  `Temperatur_ID`  int(11) NOT NULL AUTO_INCREMENT,
  `Bezeichnung`    varchar(50) NOT NULL DEFAULT '',
  `AnlagenNr`      int(11) unsigned DEFAULT '1',
  `SensorNr`       int(11) unsigned DEFAULT '1',
  `Intervall`      int(11) unsigned DEFAULT '900',
  `Speicherdauer`  int(11) unsigned DEFAULT '365',
  PRIMARY KEY (`Temperatur_ID`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8 COMMENT='utf8_general_ci';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `TempDefs`
--

LOCK TABLES `TempDefs` WRITE;
/*!40000 ALTER TABLE `TempDefs` DISABLE KEYS */;
INSERT INTO `TempDefs` VALUES (1,'Maische',1,1,30,365),(2,'Aussentemperatur',1,2,900,365),(3,'Maische',2,1,30,365);
/*!40000 ALTER TABLE `TempDefs` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `TempValues`
--

DROP TABLE IF EXISTS `TempValues`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `TempValues` (
  `Temperatur_ID` int(11) NOT NULL,
  `TempTime` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `Value` float(5,1) NOT NULL,
  PRIMARY KEY (`Temperatur_ID`,`TempTime`),
  CONSTRAINT `FK_TempValues_1` FOREIGN KEY (`Temperatur_ID`) REFERENCES `TempDefs` (`Temperatur_ID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='utf8_general_ci';
/*!40101 SET character_set_client = @saved_cs_client */;


/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;
DELIMITER $$

CREATE DEFINER=`root`@`%` PROCEDURE `spAddTemperature`(
    IN pAnlage                      int unsigned,
    IN pSensor                      int unsigned,
    IN pTemp                        float)
    MODIFIES SQL DATA
BEGIN
  DECLARE iTempID   INT UNSIGNED;
  DECLARE iInterval INT UNSIGNED;

  -- Changes:
  -- 2014-03-16 Only changed values will be stored to save space

  IF EXISTS(SELECT Temperatur_ID FROM TempDefs WHERE AnlagenNr = pAnlage AND SensorNr = pSensor) THEN
    SELECT Temperatur_ID INTO iTempID FROM TempDefs WHERE AnlagenNr = pAnlage AND SensorNr = pSensor;

    IF NOT EXISTS(SELECT 1 FROM TempValues WHERE Temperatur_ID = iTempID AND Value = pTemp ORDER BY TempTime DESC LIMIT 1) THEN
      INSERT INTO TempValues (Temperatur_ID, Value) VALUES (iTempID, pTemp);
    END IF;
  END IF;
END$$


DELIMITER ;
-- Dump completed on 2014-05-19 22:15:15
