<!DOCTYPE html>
<html>
  <head>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1.0, user-scalable=no">
  <title>Brauers-Delight</title>
  <link rel="stylesheet" href="./css/jquery.mobile-1.4.3.min.css" />
  <link rel="stylesheet" href="./css/brewtool.css" />
  <script type="text/javascript" src="./js/jquery-1.11.0.min.js"></script>
  <script type="text/javascript" src="./js/jquery.mobile-1.4.3.min.js"></script>
  <script type="text/javascript" src="./js/highcharts.js"></script>
  <script type="text/javascript" src="./js/jquery.timer.js"></script>
</head>
<body>
  <script type="text/javascript">
    var path    = './gui_conn.php';
    var sudid   = new Array();                      // aktuelle SudNr der jew. Anlage

<?
  require_once('./inc/BrewRecipe.class.php');
  require_once('./inc/BrewControl.class.php');
  require_once('./inc/dbconn.php');                // definiert das Objekt $dbconn

  // Erstmal die Anlagen aus dem Cache laden
  $success  = true;
  $anlagen  = array();
  $anlagen  = apc_fetch('brewcontrols', $success);
  if (!$success) {
    for ($i=0; $i < $AnzAnlagen; $i++) {
      $anlagen[$i] = new BrewControl();
    }
  }

  if($result = $dbconn->query("SELECT AnlagenNr, Bezeichnung FROM Anlagen ORDER BY AnlagenNr")) {
    $anlidx = 0;
    while ($row = $result->fetch_array()) {
      if (!array_key_exists($anlidx, $anlagen)) {
        $anlagen[$anlidx] = new BrewControl();
      }
      $anlagen[$anlidx]->name = $row['Bezeichnung'];
      $anlidx++;
    }
    $result->free();
  } else {
    echo "\n\n<!-- cannot find devices in database -->\n\n";
  }

  // create all handler scripts
  for($anlagen_nr=0; $anlagen_nr < count($anlagen); $anlagen_nr++) {
    // Temp-Werte für die aktuelle Anlage holen
    $data[$anlagen_nr] = array();
    $sql = "SELECT * FROM ( SELECT UNIX_TIMESTAMP(TempTime) * 1000 AS datetime, Value AS value \n
                              FROM TempValues \n
                             WHERE Temperatur_ID = (SELECT Temperatur_ID FROM TempDefs WHERE AnlagenNr = " . ($anlagen_nr + 1) . " AND SensorNr = 1 )\n
                               AND TempTime >= (SELECT MAX(logTime)  FROM Logfile WHERE LogText = 'Mashprog started') \n
                             ORDER BY TempTime DESC LIMIT 200 ) AS DD \n
                    ORDER BY datetime";
    $result = $dbconn->query($sql);
    if ($result) {
      while ($row = $result->fetch_array()) {
       $data[$anlagen_nr][] = "[{$row['datetime']}, {$row['value']}]";
      }
      $result->free();
    } else {
      echo "<!-- cannot find temperature data \n";
      echo $sql;
      echo "-->\n";
    }
?>
    // globale Variablen für die Charts anlegen
    var chart<?= $anlagen_nr; ?>;

    /**
     * Request temperature data from the server, add it to the graph and set a timeout to request again
     */
    function requestData<?= $anlagen_nr; ?>() {
      $.ajax({
        type    : 'GET',
        url     : path,
        dataType: 'json',
        data    : { temps : '1', a : <?= $anlagen_nr+1; ?> },
        success : function(pointdata) {
          chart<?= $anlagen_nr; ?>.series[0].setData(pointdata.Ist);
          chart<?= $anlagen_nr; ?>.series[1].setData(pointdata.Soll);
          setTimeout(requestData<?= $anlagen_nr; ?>, 30000);    // call it again after thirty seconds
        },
        cache: false
      });
    }

    // Temperaturregelung starten
    $(document).on('click','#btn_settargettemp<?= $anlagen_nr; ?>', function() {
      $.ajax({                        // the request
          type    : 'POST',
          url     : path,
          dataType: 'json',
          data    : { order : 'settemp', a : <?= $anlagen_nr+1; ?>, temp :  $('#targettemp<?= $anlagen_nr; ?>')[0].value },
          success : function(x, m, e) {  },
          error   : function(x, m, e) { alert('Kann die Zieltemperatur nicht senden.'); }
      });
    });

    // Temperaturregelung abbrechen
    $(document).on('click','#btn_setdonothing<?= $anlagen_nr; ?>', function() {
      // the request
      $.ajax({
          type    : 'POST',
          url     : path,
          dataType: 'json',
          data    : { order : 'donothing', a : <?= $anlagen_nr+1; ?> },
          success : function(x, m, e) {  },
          error   : function(x, m, e) { alert('Kann die Regelung nicht beenden.'); }
      });
    });

    // Maischrezept starten
    $(document).on('submit','#recipe<?= $anlagen_nr; ?>', function(e) {
      //cache the form element for use in this function
      var $this = $(this);

      //prevent the default submission of the form
      e.preventDefault();

      //run an AJAX post request to your server-side script, $this.serialize() is the data from your form being added to the request
      $.post($this.attr('action'), $this.serialize(), function (responseData) {
        //alert('OK.');
        } )
    });

    // Rastnachregulierungen
    $(document).on('click','#btn_targettempplus<?= $anlagen_nr; ?>', function() {
      // the request
      $.ajax({
          type    : 'POST',
          url     : path,
          dataType: 'json',
          data    : { order : 'addtemp', a : <?= $anlagen_nr+1; ?> },
          success : function(x, m, e) {  },
          error   : function(x, m, e) { alert('Kann die Temperatur nicht erhöhen.'); }
      });
    });
    $(document).on('click','#btn_targettempminus<?= $anlagen_nr; ?>', function() {
      // the request
      $.ajax({
          type    : 'POST',
          url     : path,
          dataType: 'json',
          data    : { order : 'subtemp', a : <?= $anlagen_nr+1; ?> },
          success : function(x, m, e) {  },
          error   : function(x, m, e) { alert('Kann die Temperatur nicht senken.'); }
      });
    });
    $(document).on('click','#btn_timeplus<?= $anlagen_nr; ?>', function() {
      // the request
      $.ajax({
          type    : 'POST',
          url     : path,
          dataType: 'json',
          data    : { order : 'addtime', a : <?= $anlagen_nr+1; ?> },
          success : function(x, m, e) {  },
          error   : function(x, m, e) { alert('Kann die Zeit nicht erhöhen.'); }
      });
    });
    $(document).on('click','#btn_timeminus<?= $anlagen_nr; ?>', function() {
      // the request
      $.ajax({
          type    : 'POST',
          url     : path,
          dataType: 'json',
          data    : { order : 'subtime', a : <?= $anlagen_nr+1; ?> },
          success : function(x, m, e) {  },
          error   : function(x, m, e) { alert('Kann die Zeit nicht verringern.'); }
      });
    });

    // Meldungspause bestätigen
    $(document).on('click','#btn_confirm<?= $anlagen_nr; ?>', function() {
      $.ajax({                        // the request
          type    : 'POST',
          url     : path,
          dataType: 'json',
          data    : { order : 'confirm', a : <?= $anlagen_nr+1; ?>},
          success : function(x, m, e) {  },
          error   : function(x, m, e) { alert('Kann die Zieltemperatur nicht senden.'); }
      });      //var frm = $('#recipe')[0];        //cache the form element for use in this function
    });

<?  // Wenn der kleine Brauhelfer aktiv ist, dann die Rezepte aus der Merkliste anzeigen und ggf. verwenden
    if ($_GLOBALS['KBH']) { ?>
      // Wenn ein KBH - Rezept verwendet wird, dann die anderen Auswahlen deaktivieren
      $(document).on('change','#rezdata<?= $anlagen_nr; ?>', function(){
          rezID = $(this).val();     // Rezept-Nr. merken
          if (rezID != 0) {
            // manuelle Rasten deaktivieren
            $("#anzsel<?= $anlagen_nr; ?>").addClass('ui-disabled').hide();
            $("#maschin<?= $anlagen_nr; ?>").addClass('ui-disabled').hide();
            $("#maschout<?= $anlagen_nr; ?>").addClass('ui-disabled').hide();
            $('#rasten<?= $anlagen_nr; ?>').html('');
          } else {
            $("#anzsel<?= $anlagen_nr; ?>").removeClass('ui-disabled').show();
            $("#maschin<?= $anlagen_nr; ?>").removeClass('ui-disabled').show();
            $("#maschout<?= $anlagen_nr; ?>").removeClass('ui-disabled').show();
            // manuelle Rasten wieder aktivieren mit 3 Rasten als Default
            $('#rastanz<?= $anlagen_nr; ?>').val(3);
            html = '';
            for (var i = 0; i < 3; i++) {
              //html += '<label>Name</label><input type="text" id="rastName<?= $anlagen_nr; ?>' + i + '" name="name<?= $anlagen_nr; ?>[' + i + ']" /><label>Age</label><input type="text" name="child' + i + 'Age" id="textAge' + i + '" />';
              html += '<div class="ui-field-contain">';
              html += '<label for="rasttemp<?= $anlagen_nr; ?>' + i + '">Temp. & Dauer:</label>';
              html += '<input type="range" name="rasttemp[<?= $anlagen_nr; ?>][' + i + ']" data-highlight="true" id="rasttemp<?= $anlagen_nr; ?>' + i + '" min="20" max="80" value="45">';
              html += '<label for="rastdauer<?= $anlagen_nr; ?>' + i + '">Dauer</label>';
              html += '<input type="range" name="rastdauer[<?= $anlagen_nr; ?>][' + i + ']" data-highlight="true" id="rastdauer<?= $anlagen_nr; ?>' + i + '" min="0" max="90" step="5" value="30">';
              html += '</div>';
            }

            $('#rasten<?= $anlagen_nr; ?>').html(html);
          }
          $('.ui-page').trigger('create');      // then tell JQM to recreate page because we added new content
        }
      )
<?  }        // if KBH ?>


    // Rasten-Eingabe aktualisieren
    $(document).on('change','#rastanz<?= $anlagen_nr; ?>', function(){ // this function runs each time the select menu is changed
      rastanz = $(this).val(); //set variable for number of children
      html = '';

      for (var i = 0; i < rastanz; i++) {
        //html += '<label>Name</label><input type="text" id="rastName<?= $anlagen_nr; ?>' + i + '" name="name<?= $anlagen_nr; ?>[' + i + ']" /><label>Age</label><input type="text" name="child' + i + 'Age" id="textAge' + i + '" />';
        html += '<div class="ui-field-contain">';
        html += '<label for="rasttemp<?= $anlagen_nr; ?>' + i + '">Temp. & Dauer:</label>';
        html += '<input type="range" name="rasttemp[<?= $anlagen_nr; ?>][' + i + ']" data-highlight="true" id="rasttemp<?= $anlagen_nr; ?>' + i + '" min="20" max="80" value="45">';
        html += '<label for="rastdauer<?= $anlagen_nr; ?>' + i + '">Dauer</label>';
        html += '<input type="range" name="rastdauer[<?= $anlagen_nr; ?>][' + i + ']" data-highlight="true" id="rastdauer<?= $anlagen_nr; ?>' + i + '" min="0" max="90" step="5" value="30">';
        html += '</div>';
      }

      $('#rasten<?= $anlagen_nr; ?>').html(html);
      $('.ui-page').trigger('create');      // then tell JQM to recreate page because we added new content
    });

    // aktuelle Werte der Steuerung holen
    function GetActvalues(event){
      $.ajax({
        type     : "GET",
        url      : path,
        datatype : "json",
        success: function(data) {
          ShowData(data); }
      });
    }

    // Geholte Werte anzeigen
    function ShowData(data) {
      data.forEach(
        function(actdata, x) {
          $('#temp'+(x)+'0').text(actdata.temp[0] + '/' + actdata.zieltemp  + ' °C');     // Akt. Maischetemperatur anzeigen
          $('#dur'+(x)+'0').text(actdata.rastdauer);            // Rastdauer anzeigen

          sudid[x] = actdata.recipe.sudid;

          // anzeigen, ob ein Programm aktiv ist
          if (actdata.recipe.IsStarted) {
            $("#btn_startprog"+(x)).text('Programm läuft');
            $("#btn_startprog"+(x)).addClass('ui-disabled');
            $("#btn_targettempplus"+(x)).removeClass('ui-disabled').addClass('ui-enabled');
            $("#btn_targettempminus"+(x)).removeClass('ui-disabled').addClass('ui-enabled');
            $("#btn_timeplus"+(x)).removeClass('ui-disabled').addClass('ui-enabled');
            $("#btn_timeminus"+(x)).removeClass('ui-disabled').addClass('ui-enabled');
          } else {
            $("#btn_startprog"+(x)).text('Mach das so');
            $("#btn_startprog"+(x)).removeClass('ui-disabled');
            $("#btn_targettempplus"+(x)).removeClass('ui-enabled').addClass('ui-disabled');
            $("#btn_targettempminus"+(x)).removeClass('ui-enabled').addClass('ui-disabled');
            $("#btn_timeplus"+(x)).removeClass('ui-enabled').addClass('ui-disabled');
            $("#btn_timeminus"+(x)).removeClass('ui-enabled').addClass('ui-disabled');
          }

          if (actdata.relbits & 7)
            $.each($("#btn_heater"+(x)+"1"), function () { $(this).addClass('myapp-deviceOn'); });
          else
            $.each($('#btn_heater'+(x)+'1'), function () { $(this).removeClass('myapp-deviceOn'); });

/*
          if (actdata.relbits & 2)
            $.each($('#btn_heater'+(x)+'2'), function () { $(this).addClass('myapp-deviceOn'); });
          else
            $.each($('#btn_heater'+(x)+'2'), function () { $(this).removeClass('myapp-deviceOn'); });

          if (actdata.relbits & 4)
            $.each($('#btn_heater'+(x)+'3'), function () { $(this).addClass('myapp-deviceOn'); });
          else
            $.each($('#btn_heater'+(x)+'3'), function () { $(this).removeClass('myapp-deviceOn'); });
*/
          if (actdata.relbits & 8)
            $.each($('#btn_mixer'+(x)), function () { $(this).addClass('myapp-deviceOn'); });
          else
            $.each($('#btn_mixer'+(x)), function () { $(this).removeClass('myapp-deviceOn'); });

          $('#message'+(x)).html(actdata.meldung);

          // Sounds abspielen
          if (actdata.meldung) {
            if      (actdata.meldung == 'Schrot rein') document.getElementById('sndbegin').play();
            else if (actdata.meldung == 'Alles aus'  ) document.getElementById('sndend').play();
            else if (actdata.meldung != ''           ) document.getElementById('sndalarm').play();
          }
        }
      )
    }

    // Temperaturgrafik(en)
    $(document).ready(function() {
      chart<?= $anlagen_nr; ?> = new Highcharts.Chart({
        chart       : { renderTo    : 'mashgraph<?= $anlagen_nr; ?>',
                        type        : 'line',
                        events      : { load    : requestData<?= $anlagen_nr; ?> } },
        title       : { text        : 'Temperaturverlauf' },
        xAxis       : { type        : 'datetime',
                        //maxZoom: 5 * 3600000, // fourteen days
                        title       : { text: 'Zeit' } },
        tooltip     : { valueSuffix : '°C' },
        yAxis       : { minPadding  : 0.2,
                        maxPadding  : 0.2,
                        title       : { text: 'Temperatur' } },
        plotOptions : { series      : { step: 'left' // or 'center' or 'right' 
                      } },
        series      : [{name        : 'Maische',
                        data        : [] },
                       {name        : 'Sollwert',
                        data        : [] }
                      ],
      });
    });



    // Start Sensorsuche
    $(document).on('click','#btn_setsensors<?= $anlagen_nr; ?>', function() {
      $.ajax({                        // the request
          type    : 'POST',
          url     : path,
          dataType: 'json',
          data    : { order : 'setsensors', a : <?= $anlagen_nr+1; ?>, sensorno :  $('#sensorno<?= $anlagen_nr; ?>')[0].value },
          success : function(x, m, e) {  },
          error   : function(x, m, e) { alert('Fehler beim Setzen des Sensors.'); }
      });
    });

    // Messabweichung Sensor setzen
    $(document).on('click','#btn_setdeviation<?= $anlagen_nr; ?>', function() {
      $.ajax({                        // the request
          type    : 'POST',
          url     : path,
          dataType: 'json',
          data    : { order : 'setdeviation', a : <?= $anlagen_nr+1; ?>, sensornr :  $('#sensornr<?= $anlagen_nr; ?>')[0].value, deviation :  $('#deviation<?= $anlagen_nr; ?>')[0].value },
          success : function(x, m, e) {  },
          error   : function(x, m, e) { alert('Fehler beim Setzen des Sensors.'); }
      });
    });

    // Anzahl Heizkreise setzen
    $(document).on('click','#btn_setheaters<?= $anlagen_nr; ?>', function() {
      $.ajax({                        // the request
          type    : 'POST',
          url     : path,
          dataType: 'json',
          data    : { order : 'setheaters', a : <?= $anlagen_nr+1; ?>, heaters :  $('#heateranz<?= $anlagen_nr; ?>')[0].value },
          success : function(x, m, e) {  },
          error   : function(x, m, e) { alert('Kann die Heizer-Anzahl nicht senden.'); }
      });
    });

    // Setze AnlagenNr.
    $(document).on('click','#btn_setanlnr<?= $anlagen_nr; ?>', function() {
      $.ajax({                        // the request
          type    : 'POST',
          url     : path,
          dataType: 'json',
          data    : { order : 'setanlnr', a : <?= $anlagen_nr+1; ?>, anlnr :  $('#anlagennr<?= $anlagen_nr; ?>')[0].value },
          success : function(x, m, e) {  },
          error   : function(x, m, e) { alert('Kann die Anlagennr. nicht senden.'); }
      });
    });
    
    // Hysterese-Werte setzen
    $(document).on('click','#btn_sethysterese<?= $anlagen_nr; ?>', function() {
      $.ajax({                        // the request
          type    : 'POST',
          url     : path,
          dataType: 'json',
          data    : { order : 'sethyst', 
                      a : <?= $anlagen_nr+1; ?>, 
                      firstoff :  $('#firstoff<?= $anlagen_nr; ?>')[0].value, 
                      secondon :  $('#secondon<?= $anlagen_nr; ?>')[0].value, 
                      heizzeit :  $('#heizzeit<?= $anlagen_nr; ?>')[0].value },
          success : function(x, m, e) {  },
          error   : function(x, m, e) { alert('Kann die Anlagennr. nicht senden.'); }
      });
    });
    
    
/*
    // Werte an den Webserver senden
    $(document).on('click','#btn_sendsettings<?= $anlagen_nr; ?>', function() {
      $.ajax({                        // the request
          type    : 'POST',
          url     : path,
          dataType: 'json',
          data    : { order : 'sendsettings', a : <?= $anlagen_nr+1; ?> },
          success : function(x, m, e) {  },
          error   : function(x, m, e) { alert('Fehler beim Übermitteln des Kommandos.'); }
      });
    });
*/

    // Einstellungen speichern
    $(document).on('click','#btn_savesettings<?= $anlagen_nr; ?>', function() {
      $.ajax({                        // the request
          type    : 'POST',
          url     : path,
          dataType: 'json',
          data    : { order : 'savesettings', a : <?= $anlagen_nr+1; ?> },
          success : function(x, m, e) {  },
          error   : function(x, m, e) { alert('Kann die Steuerungsdaten nicht ins EEPROM speichern.'); }
      });
    });

    // Steuerung zurücksetzen
    $(document).on('click','#btn_resetsettings<?= $anlagen_nr; ?>', function() {
      $.ajax({                        // the request
          type    : 'POST',
          url     : path,
          dataType: 'json',
          data    : { order : 'reset', a : <?= $anlagen_nr+1; ?> },
          success : function(x, m, e) {  },
          error   : function(x, m, e) { alert('Kann die Steuerung nicht zurücksetzen.'); }
      });
    });

<?  }     // for($anlagen_nr=0; $anlagen_nr < count($anlagen); $anlagen_nr++)

  // Wenn der kleine Brauhelfer aktiv ist, dann die Rezepte aus der Merkliste anzeigen und ggf. verwenden
    if ($_GLOBALS['KBH']) { 
?>

      // Nach der Rezeptauswahl im Schüttmaster die Schüttung anzeigen
      $(document).on('change','#smrezept', function(){
        rezID = $(this).val();     // Rezept-Nr. merken
        $.ajax({
          type    : 'GET',
          url     : path,
          dataType: 'json',
          data    : { malts : '1', SudID : rezID },
          success : function(data) {
            $('#sminfo').html(data);
            $('.ui-page').trigger('create');      // then tell JQM to recreate page because we added new content
          },
          cache: false
        });
      })
      
      // Nach der Rezeptauswahl in der Bierinfo die Daten anzeigen
      $(document).on('change','#birezept', function(){
        rezID = $(this).val();     // Rezept-Nr. merken
        $.ajax({
          type    : 'GET',
          url     : path,
          dataType: 'json',
          data    : { infos : '1', SudID : rezID },
          success : function(data) {
            $('#biinfo').html(data);
            $('.ui-page').trigger('create');      // then tell JQM to recreate page because we added new content
          },
          cache: false
        });
      })
      
<?  }        // if KBH
?>

    $.timer(GetActvalues, 10000, true);    // get values every 10 seconds
  </script>

  <audio id="sndalarm" src="./data/alarm.mp3"><p> Your browser does not support etc</p></audio>
  <audio id="sndbegin" src="./data/einmaischen.mp3"><p> Your browser does not support etc</p></audio>
  <audio id="sndend" src="./data/reinigung.mp3"><p> Your browser does not support etc</p></audio>


<?  // Hauptmenue alle Anlagen und gemeinsame Seiten
  if (count($anlagen) > 1) { ?>
  <div data-role="page" id="anlmenu">
    <div data-role="header" data-position="fixed">
      <h1>Brauers-Delight</h1>
    </div><!-- /header -->
    <div data-role="content" role="main" class="ui-content jqm-content">
<?
    // Hauptmenue alle Anlagen
    foreach($anlagen as $anlagen_nr => $aktanlage ) {
?>
      <a href="#main<?= $anlagen_nr; ?>" class="ui-btn ui-shadow ui-corner-all"><?= $anlagen[$anlagen_nr]->name; ?></a>
<?   } // for($anlagen_nr=0; $anlagen_nr < count($anlagen); $anlagen_nr++)  ?>

<?  if ($_GLOBALS['KBH']) { ?>
      <a href="#schuettmaster" class="ui-btn ui-shadow ui-corner-all">Schüttungen</a>
      <!--a href="#rastmaster" class="ui-btn ui-shadow ui-corner-all">Rastinfo</a-->
      <a href="#bierinfo" class="ui-btn ui-shadow ui-corner-all">Bierinfo</a>
<?  }        // if KBH ?>

    </div><!-- /content -->
  </div>
<? }          //if (count($anlagen) > 1) ?>


<?  // Steuerungs-Pages erzeugen
    for($anlagen_nr=0; $anlagen_nr < count($anlagen); $anlagen_nr++) {
      $EffRasten = count($anlagen[$anlagen_nr]->recipe->temp)-2; // Ein- und Abmaischen zählen auch als Rast, deswegen -2
?>
  <div data-role="page" id="main<?= $anlagen_nr; ?>">
    <div data-role="header" data-add-back-btn="true" data-position="fixed">
      <h1><?= $anlagen[$anlagen_nr]->name; ?></h1>
      <a href="#anlmenu" class="ui-btn-left ui-btn ui-mini ui-btn-inline ui-btn-icon-notext ui-corner-all ui-btn-icon-left ui-icon-bullets">Übersicht</a>
      <a href="#arduinosettings<?= $anlagen_nr; ?>" class="ui-btn-right ui-btn ui-mini ui-btn-inline ui-btn-icon-notext ui-corner-all ui-btn-icon-right ui-icon-gear">Inst.</a>
    </div><!-- /header -->
      <div data-role="content" role="main" class="ui-content jqm-content">
        <div data-role="collapsibleset" data-theme="a" data-content-theme="a">
          <div data-role="collapsible">
            <h4>Temperatur - Regelung</h4>
              <div class="ui-field-contain">
                <label data-inline="true" for="temprange<?= $anlagen_nr; ?>">Zieltemp.:</label>
                <input data-inline="true" type="range" name="targettemp<?= $anlagen_nr; ?>" data-highlight="true" id="targettemp<?= $anlagen_nr; ?>" min="20" max="80" value="45"/>
              </div>
              <div class="ui-grid-a">
                <button data-inline="true" class="ui-block-a ui-btn ui-shadow ui-icon-check ui-btn-icon-notext ui-corner-all" id="btn_settargettemp<?= $anlagen_nr; ?>"></button>
                <button data-inline="true" class="ui-block-b ui-btn ui-shadow ui-icon-delete ui-btn-icon-notext ui-corner-all" id="btn_setdonothing<?= $anlagen_nr; ?>"></button>
              </div>
          </div>
          <div data-role="collapsible">
            <h4>Maischprogramm</h4>
            <form id="recipe<?= $anlagen_nr; ?>" data-ajax="false" action="gui_conn.php">
<?            if ($_GLOBALS['KBH']) {
                if ($res= $kbdb->query("SELECT 0 AS ID, 'manuell' AS Sudname UNION SELECT ID, Sudname FROM Sud WHERE MerklistenID <> 0")) {
                  echo "              <div class='ui-field-contain'>\n";
                  echo "                <label data-inline='true' for='rezdata{$anlagen_nr}'>Rezept:</label>\n";
                  echo "                <select name='rezdata[{$anlagen_nr}]' id='rezdata{$anlagen_nr}' data-inline='true' data-native-menu='false' data-mini='true'>\n";
                  //echo "                  <option value='0' " . (($anlagen[$anlagen_nr]->recipe->sudid == 0) ? 'selected': '') . ">manuell</option>\n";
                  while($row = $res->fetchArray()) {
                    echo "                  <option value='{$row['ID']}' " . (($anlagen[$anlagen_nr]->recipe->sudid == $row['ID']) ? 'selected': '') . ">{$row['Sudname']}</option>\n";
                  }    // while
                  echo "                </select>\n";
                  echo "              </div>\n";
                }      // if $res
              }        // if KBH
?>
              <div class="ui-field-contain" id="anzsel<?= $anlagen_nr; ?>">
                <label data-inline="true" for="rastanz<?= $anlagen_nr; ?>">Rasten:</label>
                <select name="rastanz[<?= $anlagen_nr; ?>]" id="rastanz<?= $anlagen_nr; ?>" data-inline="true" data-native-menu="false" data-mini="true">
                    <option value="2" <?= ($EffRasten == 2) ? 'selected' : ''; ?> >2</option>
                    <option value="3" <?= ($EffRasten == 3) ? 'selected' : ''; ?> >3</option>
                    <option value="4" <?= ($EffRasten == 4) ? 'selected' : ''; ?> >4</option>
                    <option value="5" <?= ($EffRasten == 5) ? 'selected' : ''; ?> >5</option>
                    <option value="6" <?= ($EffRasten == 6) ? 'selected' : ''; ?> >6</option>
                    <option value="7" <?= ($EffRasten == 7) ? 'selected' : ''; ?> >7</option>
                    <option value="8" <?= ($EffRasten == 8) ? 'selected' : ''; ?> >8</option>
                </select>
              </div>
              <div class="ui-field-contain" id="maschin<?= $anlagen_nr; ?>">
                <label>Einmaischen</label>
                <input type="range" name="starttemp[<?= $anlagen_nr; ?>]" data-highlight="true" id="starttemp<?= $anlagen_nr; ?>" min="20" max="80" value="<?= $anlagen[$anlagen_nr]->recipe->temp[0]; ?>">
              </div>
              <div id="rasten<?= $anlagen_nr; ?>" >
<?              for ($rast=1; $rast <= $EffRasten; $rast++ ) {  // count($anlagen[$anlagen_nr-1]->recipe->dauer)-1; $rast++ ) { ?>
                <div class="ui-field-contain">
                  <label for="rasttemp<?= $anlagen_nr; ?><?= $rast-1; ?>" >Temp.</label>
                  <input type="range" name="rasttemp[<?= $anlagen_nr; ?>][<?= $rast-1; ?>]"  data-highlight="true" id="rasttemp<?= $anlagen_nr; ?><?= $rast-1; ?>"  min="20" max="99" value="<?= $anlagen[$anlagen_nr]->recipe->temp[$rast]; ?>">
                  <label for="rastdauer<?= $anlagen_nr; ?><?= $rast-1; ?>" >Dauer</label>
                  <input type="range" name="rastdauer[<?= $anlagen_nr; ?>][<?= $rast-1; ?>]" data-highlight="true" id="rastdauer<?= $anlagen_nr; ?><?= $rast-1; ?>" min="0"  max="90" step="5" value="<?= $anlagen[$anlagen_nr]->recipe->dauer[$rast]; ?>">
                </div>
<?              } ?>
              </div>
              <div class="ui-field-contain" id="maschout<?= $anlagen_nr; ?>">
                <label>Endtemperatur</label>
                <input type="range" name="endtemp[<?= $anlagen_nr; ?>]" data-highlight="true" id="endtemp<?= $anlagen_nr; ?>" min="20" max="80" value="<?= $anlagen[$anlagen_nr]->recipe->temp[count($anlagen[$anlagen_nr]->recipe->dauer)-1]; ?>"/>
              </div>
              <div class="ui-field-contain">
                <input type="hidden" name="order" value="startprog" />
                <input type="hidden" name="a" value="<?= $anlagen_nr+1; ?>" />
                <button data-inline="true" data-enhanced="true" class="ui-btn ui-shadow ui-icon-check ui-corner-all" id="btn_startprog<?= $anlagen_nr; ?>" >Mach das so</button>
              </div>
            </form>
            <div class="ui-field-contain ui-grid-a">
              <button data-inline="true" data-enhanced="true" class="ui-block-a ui-btn ui-shadow ui-corner-all ui-disabled" id="btn_targettempplus<?= $anlagen_nr; ?>">+1 °C</button>
              <button data-inline="true" data-enhanced="true" class="ui-block-b ui-btn ui-shadow ui-corner-all ui-disabled" id="btn_targettempminus<?= $anlagen_nr; ?>">-1 °C</button>
            </div>
            <div class="ui-field-contain ui-grid-a">
              <button data-inline="true" class="ui-block-a ui-btn ui-shadow ui-corner-all ui-disabled" id="btn_timeplus<?= $anlagen_nr; ?>">+5 Min.</button>
              <button data-inline="true" class="ui-block-b ui-btn ui-shadow ui-corner-all ui-disabled" id="btn_timeminus<?= $anlagen_nr; ?>">-5 Min.</button>
            </div>
          </div>
          <div data-role="collapsible">
            <h4>Maischtemperaturen</h4>
            <div id="mashgraph<?= $anlagen_nr; ?>" style="height:400px;"></div>
          </div>
        </div>
      </div><!-- /content -->
      <div data-role="footer" data-position="fixed">
        <table width="100%">
          <tr>
            <td colspan="4">
              <h3><center><span id="message<?= $anlagen_nr; ?>"></span></center></h3>
            </td>
            <td colspan="2">
              <button data-inline="true" class="ui-btn ui-shadow ui-icon-check ui-corner-all" id="btn_confirm<?= $anlagen_nr; ?>" >Weiter</button>
            </td>
          </tr>
          <tr>
            <td width="35%"><button class="ui-btn ui-mini ui-corner-all" ><h3 id="temp<?= $anlagen_nr; ?>0">----</h3></button></td>
            <td width="35%"><button class="ui-btn ui-mini ui-icon-clock ui-btn-icon-right ui-corner-all"><h3 id="dur<?= $anlagen_nr; ?>0">----</h3></button></td>
            <td width="15%"><button class="ui-btn ui-mini ui-icon-myapp-heater ui-btn-icon-notext ui-corner-all" id="btn_heater<?= $anlagen_nr; ?>1"></button></td>
            <!--td><button class="ui-btn ui-mini ui-btn-inline ui-icon-myapp-heater ui-btn-icon-notext ui-corner-all" id="btn_heater<?= $anlagen_nr; ?>2"></button></td>
            <td><button class="ui-btn ui-mini ui-btn-inline ui-icon-myapp-heater ui-btn-icon-notext ui-corner-all" id="btn_heater<?= $anlagen_nr; ?>3"></button></td-->
            <td width="15%"><button class="ui-btn ui-mini ui-icon-myapp-mixer ui-btn-icon-notext ui-corner-all"  id="btn_mixer<?= $anlagen_nr; ?>"></button></td>
          </tr>
        </table>
      </div><!-- /footer <?= $anlagen_nr; ?>-->
    </div><!-- /main page <?= $anlagen_nr; ?>-->
<?   } // for($anlagen_nr=1; $anlagen_nr <= count($anlagen); $anlagen_nr++)  ?>


<?  // Settings-Pages erzeugen
    for($anlagen_nr=0; $anlagen_nr < count($anlagen); $anlagen_nr++) { ?>
    <div data-role="page" id="arduinosettings<?= $anlagen_nr; ?>">
      <div data-role="header" data-add-back-btn="true" data-position="fixed">
        <h1>Einstellungen</h1>
      </div><!-- /header -->
      <div data-role="content">
        <div data-role="collapsibleset" data-theme="a" data-content-theme="a">
          <div data-role="collapsible">
            <h3>Sensoren erkennen</h3>
            <div class="ui-field-contain">
              <p>Hier werden die Adressen der Sensoren gesucht. Sensor Nr. 1 ist immer der Sensor für die Maische, also für die Haupt-Temperaturregelung. 
              Am besten sollte es sein, einen Regler nach dem anderen anzuschliessen und ihm dann durch die Suche eine interne Sensor-Nr. zuzuweisen.</p>
              <label data-inline="true" for="sensorno<?= $anlagen_nr; ?>">Suche Sensor Nr.</label>
              <select id="sensorno<?= $anlagen_nr; ?>" data-inline="true" data-native-menu="false" data-mini="true">
                <option value="0">1</option>
                <option value="1">2</option>
                <option value="2">3</option>
                <option value="3">4</option>
              </select>
            </div>
            <button data-inline="true" class="ui-btn ui-btn-mini ui-shadow ui-icon-check ui-corner-all" id="btn_setsensors<?= $anlagen_nr; ?>">OK</button>
          </div>
          <div data-role="collapsible">
            <h3>Messabweichungen</h3>
            <div class="ui-field-contain">
              <p>Diese Abweichungen (in °C) werden auf alle Messungen aufaddiert, bevor geregelt wird und bevor sie an den Server gesendet werden. Wenn also z.B. der Sensor
              immer 1 Grad zu wenig misst, dann hier eine 1 einstellen.</p>
              <label data-inline="true" for="sensornr<?= $anlagen_nr; ?>">Sensor Nr.</label>
              <select id="sensornr<?= $anlagen_nr; ?>" data-inline="true" data-native-menu="false" data-mini="true">
                <option value="0">1</option>
                <option value="1">2</option>
                <option value="2">3</option>
                <option value="3">4</option>
              </select>
            </div>
            <div class="ui-field-contain">
              <label data-inline="true" for="deviation<?= $anlagen_nr; ?>">Abweichung</label>
              <input data-inline="true" type="range" name="deviation<?= $anlagen_nr; ?>" id="deviation<?= $anlagen_nr; ?>" data-highlight="true" min="-5" max="5" value="0"/>
            </div>
            <button data-inline="true" class="ui-btn ui-btn-mini ui-shadow ui-icon-check ui-corner-all" id="btn_setdeviation<?= $anlagen_nr; ?>">OK</button>
          </div>
          <div data-role="collapsible">
            <h3>Anzahl Heizkreise einstellen</h3>
            <div class="ui-field-contain">
              <label data-inline="true" for="heateranz<?= $anlagen_nr; ?>">Anzahl</label>
              <select id="heateranz<?= $anlagen_nr; ?>" data-inline="true" data-native-menu="false" data-mini="true">
                <option value="1">1</option>
                <option value="2">2</option>
                <option value="3">3</option>
              </select>
            </div>
            <button data-inline="true" class="ui-btn ui-btn-mini ui-shadow ui-icon-check ui-corner-all" id="btn_setheaters<?= $anlagen_nr; ?>">OK</button>
          </div>
          <!--div data-role="collapsible">
            <h3>IP-Einstellungen</h3>
            <form>
              <div class="ui-field-contain">
                <label for="own<?= $anlagen_nr; ?>1">Eigene IP</label>
                <div class="ui-grid-c">
                  <div class="ui-block-a"><input type="number" name="ownip1"  id="ownip<?= $anlagen_nr; ?>1" pattern='^([01][0-9][0-9]|2[0-4][0-9]|25[0-5])$' value="192"/></div>
                  <div class="ui-block-b"><input type="number" name="ownip2"  id="ownip<?= $anlagen_nr; ?>2" pattern='^([01][0-9][0-9]|2[0-4][0-9]|25[0-5])$' value="168"/></div>
                  <div class="ui-block-c"><input type="number" name="ownip3"  id="ownip<?= $anlagen_nr; ?>3" pattern='^([01][0-9][0-9]|2[0-4][0-9]|25[0-5])$' value="100"/></div>
                  <div class="ui-block-d"><input type="number" name="ownip4"  id="ownip<?= $anlagen_nr; ?>4" pattern='^([01][0-9][0-9]|2[0-4][0-9]|25[0-5])$' value="200"/></div>
                </div>
              </div>
              <div class="ui-field-contain">
                <label for="srvip<?= $anlagen_nr; ?>1">IP Server</label>
                <div class="ui-grid-c">
                  <div class="ui-block-a"><input type="number" name="srvip1"  id="srvip<?= $anlagen_nr; ?>1" pattern='^([01][0-9][0-9]|2[0-4][0-9]|25[0-5])$' value="192"/></div>
                  <div class="ui-block-b"><input type="number" name="srvip2"  id="srvip<?= $anlagen_nr; ?>2" pattern='^([01][0-9][0-9]|2[0-4][0-9]|25[0-5])$' value="168"/></div>
                  <div class="ui-block-c"><input type="number" name="srvip3"  id="srvip<?= $anlagen_nr; ?>3" pattern='^([01][0-9][0-9]|2[0-4][0-9]|25[0-5])$' value="100"/></div>
                  <div class="ui-block-d"><input type="number" name="srvip4"  id="srvip<?= $anlagen_nr; ?>4" pattern='^([01][0-9][0-9]|2[0-4][0-9]|25[0-5])$' value="1"/></div>
                </div>
              </div>
              <label for="srvpath<?= $anlagen_nr; ?>">Pfad zur API</label>
              <input type="text" data-clear-btn="true" name="srvpath" id="srvpath<?= $anlagen_nr; ?>" pattern="[0-9]*" value="/Brauerei/connect.php" />
            </form>
            <button data-inline="true" class="ui-btn ui-btn-mini ui-shadow ui-icon-check ui-corner-all" id="btn_setheaters<?= $anlagen_nr; ?>">OK</button>
          </div-->
          <div data-role="collapsible">
            <h3>Anlagennummer einstellen</h3>
            <div class="ui-field-contain">
              <label data-inline="true" for="anlagennr<?= $anlagen_nr; ?>">Neue Anlagen-Nr.</label>
              <select id="anlagennr<?= $anlagen_nr; ?>" data-inline="true" data-native-menu="false" data-mini="true">
                <option value="1" <?= ($anlagen_nr == 1) ? 'selected' : ''; ?> >1</option>
                <option value="2" <?= ($anlagen_nr == 2) ? 'selected' : ''; ?> >2</option>
                <option value="3" <?= ($anlagen_nr == 3) ? 'selected' : ''; ?> >3</option>
                <option value="4" <?= ($anlagen_nr == 4) ? 'selected' : ''; ?> >4</option>
              </select>
            </div>
            <button data-inline="true" class="ui-btn ui-shadow ui-icon-check ui-corner-all" id="btn_setanlnr<?= $anlagen_nr; ?>">OK</button>
          </div>
          <!--div data-role="collapsible">
            <h3>Autotune starten</h3>
            <p>Die Werte für den PID Regler automatisch ermitteln. Dazu muss die Pfanne mit Maische (bzw. Wasser mit altem Treber) gefüllt sein. Dauert dann ca. 2 Stunden, also genug Zeit einplanen.</p>
            <button data-inline="true" class="ui-btn ui-btn-mini ui-shadow ui-icon-check ui-corner-all" id="btn_autotune<?= $anlagen_nr; ?>">START</button>
          </div>
          <div data-role="collapsible">
            <h3>Aktuelle Werte</h3>
            <p>Die internen Werte der Steuerung an den Webserver senden lassen : Sensoradressen, PID-Parameter, ...</p>
            <button data-inline="true" class="ui-btn ui-btn-mini ui-shadow ui-icon-check ui-corner-all" id="btn_sendsettings<?= $anlagen_nr; ?>">OK</button>
          </div-->
          <div data-role="collapsible">
            <h3>Hysterese</h3>
            <div class="ui-field-contain">
              <p>Ab wieviel °C unter Zieltemperatur soll die Dauerheizung abgeschaltet werden und ab wieviel °C soll kurz nachgeheizt werden. Bei einem gut
              isolierten Einkocher kann ca. 2,5°C vorher die Dauerheizung abgeschaltet werden und die Restwärme genutzt werden. Danach wird ab 0,5°C unter 
              Zieltemperatur "getaktet". Dieser Takt ist z.B. 30 Sekunden innerhalb eines 5-Minuten Takts als "Heiztakt".</p>
            </div>
            <div class="ui-field-contain">
              <label data-inline="true" for="firstoff<?= $anlagen_nr; ?>">Abschalten ab</label>
              <input data-inline="true" type="range" name="firstoff<?= $anlagen_nr; ?>" id="firstoff<?= $anlagen_nr; ?>" data-highlight="true" min="0" max="10.0" step="0.5" value="2.5"/>
            </div>
            <div class="ui-field-contain">
              <label data-inline="true" for="secondon<?= $anlagen_nr; ?>">Anschalten ab</label>
              <input data-inline="true" type="range" name="secondon<?= $anlagen_nr; ?>" id="secondon<?= $anlagen_nr; ?>" data-highlight="true" min="0" max="10.0" step="0.5" value="0.5"/>
            </div>
            <div class="ui-field-contain">
              <label data-inline="true" for="heizzeit<?= $anlagen_nr; ?>">Heizzeit</label>
              <input data-inline="true" type="range" name="heizzeit<?= $anlagen_nr; ?>" id="heizzeit<?= $anlagen_nr; ?>" data-highlight="true" min="10" max="200" step="5" value="30"/>
            </div>
            <button data-inline="true" class="ui-btn ui-btn-mini ui-shadow ui-icon-check ui-corner-all" id="btn_sethysterese<?= $anlagen_nr; ?>">OK</button>
          </div>
          <div data-role="collapsible">
            <h3>Einstellungen in der Steuerung speichern</h3>
            <p>Die gemachten Einstellungen so im EEPROM der Steuerung speichern, damit sie beim nächsten Start automatisch so voreingestellt sind.</p>
            <button data-inline="true" class="ui-btn ui-btn-mini ui-shadow ui-icon-check ui-corner-all" id="btn_savesettings<?= $anlagen_nr; ?>">OK</button>
          </div>
          <div data-role="collapsible">
            <h3>Steuerung zurücksetzen</h3>
            <p>Die Werte der Steuerung auf die Grundeinstellungen zurücksetzen. Diese Einstellungen werden dann im EEPROM verewigt.</p>
            <button data-inline="true" class="ui-btn ui-btn-mini ui-shadow ui-icon-check ui-corner-all" id="btn_resetsettings<?= $anlagen_nr; ?>">OK</button>
          </div>
        </div>
      </div><!-- /content -->
    </div><!-- /settings page -->
<?   } // for($anlagen_nr=0; $anlagen_nr <= count($anlagen); $anlagen_nr++)  ?>

<?  if ($_GLOBALS['KBH']) { ?>
    <div data-role="page" id="schuettmaster">
      <div data-role="header" data-add-back-btn="true" data-position="fixed">
        <h1>Schüttmaster 2000</h1>
        <a href="#anlmenu" class="ui-btn-left ui-btn ui-mini ui-btn-inline ui-btn-icon-notext ui-corner-all ui-btn-icon-left ui-icon-bullets">Übersicht</a>
      </div><!-- /header -->
      <div data-role="content">

<?  if ($res= $kbdb->query('SELECT ID, Sudname FROM Sud WHERE MerklistenID <> 0')) { ?>
        <div class='ui-field-contain'>
          <label data-inline='true' for='smrezept'>Rezept:</label>
          <select id='smrezept' data-inline='true' data-native-menu='false' data-mini='true'>
            <option value='0' selected>manuell</option>
<?        while($row = $res->fetchArray()) { ?>
            <option value="<?= $row['ID']; ?>"><?= $row['Sudname']; ?></option>
<?        }    ?> 
          </select>
         </div>
<?      }                // if $res ?>

        <div id='sminfo'></div>
      </div><!-- /content -->
    </div><!-- /page -->


    <div data-role="page" id="bierinfo">
      <div data-role="header" data-add-back-btn="true" data-position="fixed">
        <h1>Infos zu aktuellen Bieren</h1>
        <a href="#anlmenu" class="ui-btn-left ui-btn ui-mini ui-btn-inline ui-btn-icon-notext ui-corner-all ui-btn-icon-left ui-icon-bullets">Übersicht</a>
      </div><!-- /header -->
      <div data-role="content">

<?  if ($res= $kbdb->query('SELECT ID, Sudname FROM Sud WHERE BierWurdeAbgefuellt = 1 AND BierWurdeVerbraucht = 0')) { ?>
        <div class='ui-field-contain'>
          <label data-inline='true' for='birezept'>Bier:</label>
          <select id='birezept' data-inline='true' data-native-menu='false' data-mini='true'>
            <option value='0' selected>manuell</option>
<?        while($row = $res->fetchArray()) { ?>
            <option value="<?= $row['ID'];?>"><?=$row['Sudname'];?></option>
<?        }    // while ?>
          </select>
        </div>
<?    }      // if $res ?>

        <div id='biinfo'></div>
      </div><!-- /content -->
    </div><!-- /page -->
<?  }        // if KBH ?>
</body>
</html>
